#
# Example 16-11
# Downloading files with http_get.
#

#!/usr/local/tclsh8.0
if {$argc < 2} {
	puts stderr "Usage: $argv0 url file"
	exit 1
}
set url [lindex $argv 0]
set file [lindex $argv 1]
set out [open $file w]

proc progress {token total current} {
	puts -nonewline "."
}
http_config -proxyhost webcache.eng -proxyport 8080
set token [http_get $url -progress progress \
	-headers {Pragma no-cache} -channel $out]
close $out

# Print out the return header information
puts ""
upvar #0 $token state
puts $state(http)
foreach {key value} $state(meta) {
	puts "$key: $value"
}
exit 0


