# cgilib.tcl

# This has code that is not in any examples.
# The test script in exsource adds this to the
# example sources to make a real cgilib.tcl

proc Cgi_End {} {
    puts </Body>
}
proc Cgi_Redirect {url} {
    puts stdout "\
Content-type: text/html
Location: $url

Please go to $url
"
}
proc H1 {str} {
    Html_Tag H1 {} $str
}
proc H2 {str} {
    Html_Tag H2 {} $str
}
proc H3 {str} {
    Html_Tag H3 {} $str
}
proc H4 {str} {
    Html_Tag H4 {} $str
}
proc H5 {str} {
    Html_Tag H5 {} $str
}
proc H6 {str} {
    Html_Tag H6 {} $str
}
proc P {} {
    puts stdout <p>
}
proc UL {html} {
    puts stdout "<ul>\n$html\n</ul>"
}
proc OL {html} {
    puts stdout "<ol>\n$html\n</ol>"
}
proc LI {html} {
    return "<li>$html"
}
proc Link {text href} {
    return "<a href=\"$href\">$text</a>"
}
proc Html_Tag {tag params str} {
    puts stdout "<[string trim "$tag $params"]>$str</$tag>"
}
proc Form {url {method POST}} {
    puts stdout "<form action=\"$url\" method=$method>"
}
proc Counter {filename} {
    if [catch {open $filename} in] {
	set number 0
    } else {
	set info [read $in]
	close $in
	if ![regexp {[0-9]+} $info number] {
	    return [clock seconds]	;# Bail - race with file access
	}
    }
    incr number
    set out [open $filename.next w]
    puts $out $number
    close $out
    exec mv -f $filename.next $filename
    return $number
}
#
# Example 3-4
# The Cgi_Header procedure.
#

proc Cgi_Header {title {bodyparams {}}} {
    puts stdout \
"Content-Type: text/html

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY $bodyparams>
<H1>$title</H1>"
}


#
# Example 11-3
# The Url_Decode procedure.
#

proc Url_Decode {url} {
	regsub -all {\+} $url { } url
	regsub -all {%([0-9a-hA-H][0-9a-hA-H])} $url \
		{[format %c 0x\1]} url
	return [subst $url]
}


#
# Example 11-4
# The Cgi_Parse and Cgi_Value procedures.
#

proc Cgi_Parse {} {
	global cgi env
	if [info exists env(QUERY_STRING)] {
		# This comes from GET-style forms
		set query $env(QUERY_STRING)
	} elseif {[info exists env(CONTENT_LENGTH)]} {
		# This comes from POST-style forms
		set query [read stdin $env(CONTENT_LENGTH)]
	} else {
		# No content-length so it is only safe to read one line
		gets stdin query
	}
	foreach {name value} [split $query &=] {
		lappend cgi([Url_Decode $name]) [Url_Decode $value]
	}
}
proc Cgi_Value {name} {
	global cgi
	if ![info exists cgi($name)] {
		return {}
	} elseif {[llength $cgi($name)] == 1} {
		# Strip a level of listing for convenience
		return [lindex $cgi($name) 0]
	} else {
		# Return the whole list of values
		return $cgi($name)
	}
}


